- Set "listener" to -1 after we close it so that the error-handler
[rsync/rsync.git] / testsuite / rsync.fns
CommitLineData
d820215b
MP
1#! /bin/sh
2
3# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5# General-purpose test functions for rsync.
3a4c683f 6
0154b302
MP
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version
9# 2 as published by the Free Software Foundation.
10#
11# This program is distributed in the hope that it will be useful, but
12# WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14# Lesser General Public License for more details.
15#
16# You should have received a copy of the GNU Lesser General Public
17# License along with this program; if not, write to the Free Software
18# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
6f481bb0 21tmpdir="$scratchdir"
e3442095
WD
22fromdir="$tmpdir/from"
23todir="$tmpdir/to"
24chkdir="$tmpdir/chk"
3a4c683f 25
2094283b 26# Berkley's nice.
96553aa7 27PATH="$PATH:/usr/ucb"
2094283b 28
e3442095 29if diff -u "$srcdir/testsuite/rsync.fns" "$srcdir/testsuite/rsync.fns" >/dev/null 2>&1; then
84229c7a
WD
30 diffopt="-u"
31else
32 diffopt="-c"
33fi
34
3a4c683f
MP
35runtest() {
36 echo $ECHO_N "Test $1: $ECHO_C"
501972bf
MP
37 if eval "$2"
38 then
6f481bb0 39 echo "$ECHO_T done."
501972bf
MP
40 return 0
41 else
6f481bb0 42 echo "$ECHO_T failed!"
501972bf
MP
43 return 1
44 fi
3a4c683f
MP
45}
46
47printmsg() {
48 echo "$1"
49}
50
e052b21f 51
6773a779 52rsync_ls_lR() {
dfef3f10
MP
53 find "$@" -print | sort | xargs "$TOOLDIR/tls"
54}
55
56rsync_getgroups() {
57 "$TOOLDIR/getgroups"
57835c00
MP
58}
59
60
e052b21f 61####################
6f481bb0 62# Build test directories $todir and $fromdir, with $fromdir full of files.
e052b21f 63
3a4c683f 64hands_setup() {
501972bf 65 # Clean before creation
6f481bb0
WD
66 rm -rf "$fromdir"
67 rm -rf "$todir"
3d807132 68
e3442095
WD
69 [ -d "$tmpdir" ] || mkdir "$tmpdir"
70 [ -d "$fromdir" ] || mkdir "$fromdir"
71 [ -d "$todir" ] || mkdir "$todir"
3a4c683f 72
e052b21f
MP
73 # On some BSD systems, the umask affects the mode of created
74 # symlinks, even though the mode apparently has no effect on how
75 # the links behave in the future, and it cannot be changed using
76 # chmod! rsync always sets its umask to 000 so that it can
77 # accurately recreate permissions, but this script is probably run
78 # with a different umask.
79
80 # This causes a little problem that "ls -l" of the two will not be
81 # the same. So, we need to set our umask before doing any creations.
82
3a4c683f 83 # set up test data
6f481bb0
WD
84 touch "$fromdir/empty"
85 mkdir "$fromdir/emptydir"
e8ca5901 86
571a4b26 87 # a hundred lines of text or so
6f481bb0 88 rsync_ls_lR "$srcdir" > "$fromdir/filelist"
3a4c683f 89
6f481bb0 90 echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
0154b302 91 umask 0
6f481bb0 92 ln -s nolf "$fromdir/nolf-symlink"
4c80c473 93 umask 022
0154b302 94
6f481bb0
WD
95 cat $srcdir/*.c > "$fromdir/text"
96 mkdir "$fromdir/dir"
97 cp "$fromdir/text" "$fromdir/dir"
98 mkdir "$fromdir/dir/subdir"
99 echo some data > "$fromdir/dir/subdir/foobar.baz"
100 mkdir "$fromdir/dir/subdir/subsubdir"
101 ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
102 mkdir "$fromdir/dir/subdir/subsubdir2"
103 ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
7d691654 104
8f98c608 105# echo testing head:
6f481bb0 106# ls -lR "$srcdir" | head -10 || echo failed
3a4c683f 107}
3fedd74b
MP
108
109
99cdaff7
MP
110####################
111# Many machines do not have "mkdir -p", so we have to build up long paths.
112# How boring.
113makepath () {
7c1b7890 114 echo " makepath $1"
99cdaff7
MP
115 p="$1"
116 (
117 # Absolut Unix.
118 if echo $p | grep '^/' >/dev/null
119 then
120 cd /
121 fi
122
123 # This will break if $1 contains a space.
124 for c in `echo $p | tr '/' ' '`
125 do
112e7311
MP
126 if [ -d "$c" ] || mkdir "$c"
127 then
128 cd "$c" || return $?
129 else
130 echo "failed to create $c" >&2; return $?
131 fi
99cdaff7
MP
132 done
133 )
134}
135
136
137
3fedd74b
MP
138###########################
139# Run a test (in '$1') then compare directories $2 and $3 to see if
140# there are any difference. If there are, explain them.
141
f494f286
MP
142# So normally basically $1 should be an rsync command, and $2 and $3
143# the source and destination directories. This is only good when you
144# expect to transfer the whole directory exactly as is. If some files
145# should be excluded, you might need to use something else.
146
3fedd74b 147checkit() {
3fedd74b 148 failed=
3fedd74b 149
cf72f204
MP
150 # We can just write everything to stdout/stderr, because the
151 # wrapper hides it unless there is a problem.
152
153 echo "Running: \"$1\""
154 eval "$1"
3fedd74b
MP
155 status=$?
156 if [ $status != 0 ]; then
157 failed="YES";
158 fi
159
cf72f204
MP
160 echo "-------------"
161 echo "check how the files compare with diff:"
162 echo ""
d58e4c27
MP
163 for f in `cd "$2"; find . -type f -print `
164 do
84229c7a 165 diff $diffopt "$2"/"$f" "$3"/"$f" || failed=YES
d58e4c27
MP
166 done
167
cf72f204
MP
168 echo "-------------"
169 echo "check how the directory listings compare with diff:"
170 echo ""
6f481bb0
WD
171 ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
172 ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
173 diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed=YES
174 if [ -z "$failed" ] ; then
3fedd74b
MP
175 return 0
176 else
3fedd74b
MP
177 return 1
178 fi
179}
180
863dff51 181
4a7cb3e8 182build_rsyncd_conf() {
d2094cc3
MP
183 # Build an appropriate configuration file
184 conf="$scratchdir/test-rsyncd.conf"
185 echo "building configuration $conf"
186
187 port=2612
188 pidfile="$scratchdir/rsyncd.pid"
189 logfile="$scratchdir/rsyncd.log"
190
6f481bb0 191 cat >"$conf" <<EOF
3aae15ec 192# rsyncd configuration file autogenerated by $0
d2094cc3 193
3aae15ec
MP
194pid file = $pidfile
195use chroot = no
196hosts allow = localhost, 127.0.0.1
197log file = $logfile
6f481bb0 198exclude = foobar.baz
eddeaf76 199max verbosity = 9
d2094cc3 200
76ee1d18
WD
201uid = 0
202gid = 0
98c1b325 203
2e6c7f45 204[test-from]
6f481bb0 205 path = $fromdir
3aae15ec 206 read only = yes
d2094cc3 207
2e6c7f45 208[test-to]
6f481bb0 209 path = $todir
3aae15ec 210 read only = no
d2094cc3
MP
211EOF
212}
213
214
3cd2af41 215build_symlinks() {
3cd2af41
MP
216 mkdir "$fromdir"
217 date >"$fromdir/referent"
218 ln -s referent "$fromdir/relative"
219 ln -s "$fromdir/referent" "$fromdir/absolute"
220 ln -s nonexistent "$fromdir/dangling"
1db8b61d 221 ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
3cd2af41
MP
222}
223
224test_fail() {
225 echo "$@" >&2
226 exit 1
227}
228
a217ad30
MP
229test_skipped() {
230 echo "$@" >&2
6f481bb0 231 echo "$@" > "$tmpdir/whyskipped"
a217ad30
MP
232 exit 77
233}
234
be2f866b
MP
235# It failed, but we expected that. don't dump out error logs,
236# because most users won't want to see them. But do leave
237# the working directory around.
238test_xfail() {
239 echo "$@" >&2
240 exit 78
241}
242
d1239eae
MP
243# Determine what shell command will appropriately test for links.
244ln -s foo "$scratchdir/testlink"
245for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
246do
247 for switch in -h -L
248 do
249 if $cmd $switch "$scratchdir/testlink" 2>/dev/null
250 then
251 # how nice
252 TEST_SYMLINK_CMD="$cmd $switch"
253 # i wonder if break 2 is portable?
254 break 2
255 fi
256 done
257done
cca4e067
MP
258# ok, now get rid of it
259rm "$scratchdir/testlink"
d1239eae
MP
260
261
262if [ "x$TEST_SYMLINK_CMD" = 'x' ]
263then
264 test_fail "Couldn't determine how to test for symlinks"
265else
266 echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
267fi
268
269
d96d3893
MP
270# Test whether something is a link, allowing for shell peculiarities
271is_a_link() {
d1239eae
MP
272 # note the variable contains the first option and therefore is not quoted
273 $TEST_SYMLINK_CMD "$1"
d96d3893
MP
274}
275
77867907
MP
276
277# We need to set the umask to be reproducible. Note also that when we
278# do some daemon tests as root, we will setuid() and therefore the
279# directory has to be writable by the nobody user in some cases. The
280# best thing is probably to explicitly chmod those directories after
281# creation.
282
ad301e48 283umask 022